// HelloWorldDlg.cpp : implementation file
//
#include "stdafx.h"
#include "HelloWorld.h"
#include "HelloWorldDlg.h"
#include "PDFlibAX.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog {
public:
	CAboutDlg();

	// Dialog Data
	enum {
		IDD = IDD_ABOUTBOX
	};

protected:
	virtual void DoDataExchange(CDataExchange* pDX); // DDX/DDV support

	// Implementation
	DECLARE_MESSAGE_MAP()
	public : afx_msg void OnBnClickedOk();
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD) {
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog) ON_BN_CLICKED(IDOK,
	&CAboutDlg::OnBnClickedOk) END_MESSAGE_MAP()

	// CHelloWorldDlg dialog

	CHelloWorldDlg::CHelloWorldDlg(CWnd* pParent /* =NULL */)
	: CDialog(CHelloWorldDlg::IDD, pParent) {
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHelloWorldDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CHelloWorldDlg, CDialog) ON_WM_SYSCOMMAND() ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	// }}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_HELLO_WORLD, &CHelloWorldDlg::OnBnClickedHelloWorld)
	END_MESSAGE_MAP()

	// CHelloWorldDlg message handlers

	BOOL CHelloWorldDlg::OnInitDialog() {
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL) {
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE); // Set big icon
	SetIcon(m_hIcon, FALSE); // Set small icon

	// TODO: Add extra initialization here

	return TRUE; // return TRUE  unless you set the focus to a control
}

void CHelloWorldDlg::OnSysCommand(UINT nID, LPARAM lParam) {
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else {
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon.  For MFC applications using the document/view model,
// this is automatically done for you by the framework.

void CHelloWorldDlg::OnPaint() {
	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND,
			reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else {
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
// the minimized window.
HCURSOR CHelloWorldDlg::OnQueryDragIcon() {
	return static_cast<HCURSOR>(m_hIcon);
}

void CHelloWorldDlg::OnBnClickedHelloWorld() {
	// Create simple hellow world sample
	/*
	 PDFlibrary
	 Sample #1: HelloWorld

	 * This sample shows how to draw some simple text onto the page and save the PDF
	 * A file called 1.hello-world.pdf is written to disk
	 
	 * You will also need to register the ActiveX edition of the library.
	 * Read the ActiveX Getting Started Guide for information on how to do this.
	 */

	// Declare and load PDFlibrary ActiveX
	PDFlibAX PDFlib;

	// PDF output filename
	std::wstring StrFileName = L"Helloworld.pdf";

	// Display message containing the library version
	std::wstring StrMessage = L"PDFlibrary ActiveX HelloWorld sample";
	StrMessage.append(L"\n");
	StrMessage.append(L"Library version: " + PDFlib.LibraryVersion());

	// Draw the 'HelloWorld' text on the PDF page
	PDFlib.DrawText(100, 300, L"HelloWorld from C++");

	// Attempt to save the file
	if (PDFlib.SaveToFile(StrFileName) == 1) {
		// Display message that the 'Hello Word' file has been written successfully
		StrMessage.append(L"\n");
		StrMessage.append(L"\nFile " + StrFileName + L" written successfully");
		AfxMessageBox(CString(StrMessage.c_str()), MB_ICONINFORMATION);
	}
	else {
		// Display cannot write to file message
		StrMessage.append(L"\n");
		StrMessage.append(L"Error, file could not be written");
		AfxMessageBox(CString(StrMessage.c_str()), MB_ICONSTOP);
	}

}

void CAboutDlg::OnBnClickedOk() {
	// TODO: Add your control notification handler code here
	OnOK();
}
